diff --git a/src/aggregate/aggregate_exec.c b/src/aggregate/aggregate_exec.c
index 672ee143d..5b59f63c3 100644
--- a/src/aggregate/aggregate_exec.c
+++ b/src/aggregate/aggregate_exec.c
@@ -92,6 +92,9 @@ static size_t serializeResult(AREQ *req, RedisModuleCtx *outctx, const SearchRes
         // printf("Skipping hidden field %s/%p\n", kk->name, kk);
         continue;
       }
+      if (req->outFields.explicitReturn && (kk->flags & RLOOKUP_F_EXPLICITRETURN) == 0) {
+        continue;
+      }
       const RSValue *v = RLookup_GetItem(kk, &r->rowdata);
       if (!v) {
         continue;
diff --git a/src/aggregate/aggregate_request.c b/src/aggregate/aggregate_request.c
index a2bf92b71..18ef00462 100644
--- a/src/aggregate/aggregate_request.c
+++ b/src/aggregate/aggregate_request.c
@@ -965,7 +965,6 @@ int buildOutputPipeline(AREQ *req, QueryError *status) {
   RLookup *lookup = AGPLN_GetLookup(pln, NULL, AGPLN_GETLOOKUP_LAST);
   // Add a LOAD step...
   const RLookupKey **loadkeys = NULL;
-  size_t nloadkeys = 0;
   if (req->outFields.explicitReturn) {
     // Go through all the fields and ensure that each one exists in the lookup stage
     for (size_t ii = 0; ii < req->outFields.numFields; ++ii) {
@@ -977,10 +976,11 @@ int buildOutputPipeline(AREQ *req, QueryError *status) {
         goto error;
       }
       *array_ensure_tail(&loadkeys, const RLookupKey *) = lk;
-      nloadkeys++;
+      // assign explicit output flag
+      lk->flags |= RLOOKUP_F_EXPLICITRETURN;
     }
   }
-  rp = RPLoader_New(lookup, loadkeys, nloadkeys);
+  rp = RPLoader_New(lookup, loadkeys, loadkeys ? array_len(loadkeys) : 0);
   if (loadkeys) {
     array_free(loadkeys);
   }
@@ -1004,8 +1004,6 @@ int buildOutputPipeline(AREQ *req, QueryError *status) {
     PUSH_RP();
   }
 
-  if ((req->reqflags & QEXEC_F_IS_SEARCH) && !(req->reqflags & QEXEC_F_SEND_NOFIELDS)) {
-  }
   return REDISMODULE_OK;
 error:
   return REDISMODULE_ERR;
diff --git a/src/pytest/test.py b/src/pytest/test.py
index 3335fcfea..429360ef7 100644
--- a/src/pytest/test.py
+++ b/src/pytest/test.py
@@ -1380,8 +1380,11 @@ def get_stats(r):
         env.assertEqual([0], res)
 
 def testReturning(env):
-    env.assertCmdOk('ft.create', 'idx', 'schema', 'f1',
-                     'text', 'f2', 'text', 'n1', 'numeric', 'f3', 'text')
+    env.assertCmdOk('ft.create', 'idx', 'schema',
+                     'f1', 'text',
+                     'f2', 'text',
+                     'n1', 'numeric', 'sortable',
+                     'f3', 'text')
     for i in range(10):
         env.assertCmdOk('ft.add', 'idx', 'DOC_{0}'.format(i), 1.0, 'fields',
                          'f2', 'val2', 'f1', 'val1', 'f3', 'val3',
@@ -1405,6 +1408,14 @@ def testReturning(env):
             env.assertEqual(field, fields[0])
             env.assertTrue(docname.startswith('DOC_'))
 
+    # Test that we don't return SORTBY fields if they weren't specified
+    # also in RETURN
+    res = env.cmd('ft.search', 'idx', 'val*', 'return', 1, 'f1',
+        'sortby', 'n1', 'ASC')
+    row = res[2]
+    # get the first result
+    env.assertEqual(['f1', 'val1'], row)
+
     # Test when field is not found
     # Note: DISABLED because returning fields not in schema is now an ERROR
     # res = env.cmd('ft.search', 'idx', 'val*', 'return', 1, 'nonexist')
diff --git a/src/rlookup.h b/src/rlookup.h
index c972f3fa9..1f7e074b6 100644
--- a/src/rlookup.h
+++ b/src/rlookup.h
@@ -168,6 +168,13 @@ typedef struct {
  */
 #define RLOOKUP_F_UNRESOLVED 0x200
 
+/**
+ * The opposite of F_HIDDEN. This field is specified as an explicit return in
+ * the RETURN list, so ensure that this gets emitted. Only set if
+ * explicitReturn is true in the aggregation request.
+ */
+#define RLOOKUP_F_EXPLICITRETURN 0x400
+
 /**
  * These flags do not persist to the key, they are just options to GetKey()
  */
